use(io).

alu_op:type=scalar.
alu_mov:val(alu_op).
alu_add:val(alu_op).
alu_sub:var(alu_op).

alu(op:val(alu_op),x:val(int),y:val(int)):expr(int)=(
  case op
    when alu_mov => x
    when alu_add => x+y
    when alu_sub => x-y
).

opcode:var(int).
op1:var(int).
op2:var(int).
result:var(int).

opcode:=2;
op1:=512;
op2:=128;

result:=alu(case opcode when 0 => alu_mov
                        when 1 => alu_add
                        when 2 => alu_sub, op1, op2);

print(result);
print('\n')
