
/* Infix expression for bitfield extraction */

use(io).

_:_.._ : infix(200,none).

(n:val(int)) : (end:val(int)) .. (start:val(int)) : expr(int) = (
  (n>>start) and ((1<<(end-start+1))-1)
).

instr:var(int).

instr:=16#678;

print(instr:3..0);  /* opcode in bits 0-3 */
print('\n');
print(instr:7..4);  /* register 1 in bits 4-7 */
print('\n');
print(instr:11..8); /* register 2 in bits 8-11 */
print('\n')

